<?php
    include ("config.php");

    class AdifScan
    {
    var $fp;
    function AdifScan($fname)
    {
        $this->fp = fopen($fname, "rb");
        if ($this->fp)
        {   // position to <EOH>
            while (!feof($this->fp))
            {
                $c = fgetc($this->fp);
                if ($c == "<") $str="";
                $str = $str . $c;
                if ($str == "<EOH>")
                    return;
            }
            fclose($fp);
            $fp = null;
        }
    }
    function openOK() { return $this->fp ? 1 : 0; }
    function close() {fclose($this->fp);}
    function nextRecord()
    {   // return the next QSO record from ADIF as an array
        // The array will have no entries when we reach eof
        $ret = array();
        $parseState = 0;
        $tagName = "";
        $valueLen = 0;
        $value = "";
        while (!feof($this->fp))
        {
            $c = fgetc($this->fp);
            switch ($parseState)
            {
            case 0: // looking for tag
                if ($c == "<") $tagName = "";
                elseif ($c == ":")
                {
                    $valueLen = 0;
                    $parseState++;
                    break;
                }
                elseif ($c == ">")
                {
                    if ($tagName == "EOR")  return $ret;
                }
                else    $tagName = $tagName . $c;
                break;
            case 1: // looking for value length
                if ($c == ">") 
                {
                    $parseState++;
                    break;
                }
                $valueLen *= 10;
                $valueLen += $c;
                break;
            case 2: // reading value
                if ($valueLen-- <= 0)
                {
                    $ret[$tagName] = $value;
                    $value = "";
                    $parseState = 0;
                    break;
                }
                $value = $value . $c;
                break;
            }
        }
        return $ret;
    }
    }

    // php Execution starts here....
    $queryString = $_REQUEST["callsign"];
    $skipMatches = $_REQUEST["skip"];
    $matchUsingRegularExpression = $_REQUEST["useRE"];
    $toSkip = $skipMatches;
    $matchingQsos = array();
    $adif = new AdifScan($subdirectoryName . $adifFileName);
    if (!$adif->openOK()) die;
    if ($queryString != "")
    while (count($matchingQsos) < $maxQsosFromQuery)
    {
        $vals = $adif->nextRecord();
        if (count($vals) == 0)
            break;
        $matches = false;
        $thisCall = $vals["CALL"];
        if ($matchUsingRegularExpression)
        {
            $matches = preg_match($queryString, $thisCall);
        }
        else
        {
            $matches = (strtoupper($queryString) == strtoupper($thisCall));
        }
        if ($matches && !($toSkip-- > 0))
            array_push($matchingQsos, $vals);
    }
    $adif->close();

?>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
    <title>Log for station <?php echo $myCallSign; ?></title>
<?php
    $pbPositions = array();
    for ($i = 0; $i < count($matchingQsos); $i++)
    {
        $t = $matchingQsos[$i]["QSO_DATE"];
        $year = substr($t,0,4);
        $month = substr($t,4,2);
        $day = substr($t,6,2);
        $t = $matchingQsos[$i]["TIME_ON"];
        $hour = substr($t,0,2);
        $min = substr($t,2,2);
        $sec = substr($t,4,2);
        // convert to seconds since the beginning of the Unix epoch
        $playbackPos = mktime($hour,$min,$sec,$month,$day,$year,0);
        $pbPositions[$i] = $playbackPos;
    }
?>

</head>
<body background='#ffffff'>
   <table style='background-color: #ffffff;text-align: center' border='1' ><tr><td>
    <h1>Contest log for <?php echo $myCallSign; ?></h1> 
    <?php echo $contestName; ?>
    <?php if (count($matchingQsos)) { ?>
    
    <table rules='cols' frame='border' >
    <caption style='font-size: 16pt'><strong>Matching QSOs</strong></caption>
    <colgroup width='105'/>   <!--DATE-->
    <colgroup width='60'/>    <!--TIME-->
    <colgroup width='60'/>    <!--FREQ-->
    <colgroup width='50'/>    <!--MOD-->
    <colgroup width='100'/>   <!--CALL-->
    <thead style="color: #008800; text-align: center; font-family:Arial">
    <tr><td>DATE</td><td>TIME</td><td>FREQ</td><td>MOD</td><td>CALL</td><td>Audio</td></tr></thead>
    <tbody style="font-family: Courier New;">
<?php
    for ($i = 0; $i < count($matchingQsos); $i++)
    {
        $vals = $matchingQsos[$i];
        if (count($vals) == 0)
            break;
?>
        <tr><td>
<?php
        $date1 = $vals["QSO_DATE"];
        $date = substr($date1,0,4)."-".substr($date1,4,2)."-".substr($date1,6,2);
        echo ($date."</td><td>");
        echo (substr($vals["TIME_ON"],0,4)."</td><td>");
        $freq = $vals["FREQ"] * 1000;
        $freq = (int)($freq + 0.5);
        echo ($freq);
        echo ("</td><td>" . $matchingQsos[$i]["MODE"]);
        echo ("</td><td>".$vals["CALL"]."</td>");

	$n1mmTimedate = substr($date1,0,4).substr($date1,4,2).substr($date1,6,2)."_".substr($vals["TIME_ON"],0,6);
        foreach (glob ("${subdirectoryName}*{$n1mmTimedate}*.[mM][pP]3") as $n1mmFiles) { // Grab the recording that matches
                if (file_exists(${n1mmFiles})) { // Check that the file actually exists before playing it.
			$audioFile = $n1mmFiles;
			}
		else {
			$audioFile = '';
			}
		}
    ?>

        <td><a href='<?php echo $audioFile; ?>'>Download</a></td>
        </tr>
<?php
    }
    echo "</tbody></table>";
    } // if (count($matchingQsos)
?>
    <table border='1' >
    <caption style='font-size: 16pt'><strong>Search for QSOs</strong></caption>
    <tr><td><form action='<?php echo $mainPageName;?>' method='post'> 
    Callsign: <input type="text" name="callsign" value='<?php echo($queryString); ?>'/><br/>
<?php
    if ($enableMatchUsingRegularExpression)
        echo("<input type='checkbox' name='useRE'". ($matchUsingRegularExpression ? "checked=true" : "").
                " /> Search by RE <br/>\n");
    if ((count($matchingQsos) >= $maxQsosFromQuery) && $matchUsingRegularExpression)
        echo("Matches to skip: <input type='text' name='skip' maxlength='5' size='5' value='" . 
        ($skipMatches + $maxQsosFromQuery) . "' /><br/>\n");
?>
    <input type='submit' value='Lookup in log'/>
    </form> </td></tr>
        <?php if ($enableMatchUsingRegularExpression) { ?>
        <tr>
            <td>
                <span style="font-size: 10pt">
                    <?php 
            if ($enableMatchUsingRegularExpression) { ?>
                    <p>
                        <strong>Search by RE</strong> means the "Callsign" you enter is a 
                        UNIX regular expression.
                        Have a look at 
                        <a href="http://php.net/manual/en/function.preg-match.php">the documention</a> 
                        for details.
                        For a simple example, this string will return all the QSOs in the log:
                        <strong>~.*~</strong>
                    </p>
                    <?php } ?>
                </span>

            </td>
        </tr>
        <?php } ?>
</body>
</html>
